package
{
	import caurina.transitions.Tweener;
	
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.media.Sound;
	
	public class CarouselView extends Sprite
	{
		[Embed(source="click.mp3")]
		private static var ClickSound:Class;
		
		public var spinning:Boolean = false;
		
		private const TRANSITION_TIME:Number = 1.5;
		private const TRANSITION_STEPS:int = 20;
		private const SIZE_OUT:Number = .5;
		private const ALPHA_OUT:Number = .4;
		
		private var photos:PhotoList;
		private var imageIn:Bitmap;
		private var imageOut:Bitmap;

		private var spinStep:int;
		private var click:Sound = new ClickSound() as Sound;
		
		public function CarouselView(data:PhotoList)
		{
			photos = data;
		}

		public function spin():void {
			spinning = true;
			spinStep = TRANSITION_STEPS - 5 + int(Math.random()*10);
			swapImage();
		}
		
		private function swapImage():void {
			click.play();
			imageOut = imageIn;
			
			if (imageOut) {
				var newImageOutWidth:Number  = imageOut.width * SIZE_OUT;
				var newImageOutHeight:Number = imageOut.width * SIZE_OUT;
				
				Tweener.addTween(imageOut, {x:-newImageOutWidth-1, y:(stage.stageHeight - newImageOutHeight)/2,
											width:newImageOutWidth, height:newImageOutHeight, alpha:ALPHA_OUT, 
											time:TRANSITION_TIME/spinStep, transition:"easeInOutSine"});
			}
			
			imageIn = new Bitmap(photos.nextImage.bitmapData);
			var imageInRatio:Number = imageIn.width / imageIn.height;
			var stageRatio:Number = stage.stageWidth / stage.stageHeight;
			var fullImageInWidth:Number;
			var fullImageInHeight:Number;
			
			if (stageRatio > imageInRatio) { 
				fullImageInWidth = stage.stageHeight * imageInRatio;
				fullImageInHeight = stage.stageHeight;
			}
			else {
				fullImageInWidth = stage.stageWidth;
				fullImageInHeight = stage.stageWidth / imageInRatio;
			}
			
			imageIn.alpha = ALPHA_OUT;
			imageIn.width  = fullImageInWidth * SIZE_OUT;
			imageIn.height = fullImageInHeight * SIZE_OUT;
			imageIn.x = stage.stageWidth;
			imageIn.y = (stage.stageHeight - imageIn.height)/2;
			addChild(imageIn);
			
			Tweener.addTween(imageIn, {x:(stage.stageWidth-fullImageInWidth)/2, y:(stage.stageHeight-fullImageInHeight)/2,
									   width:fullImageInWidth, height:fullImageInHeight, alpha:1,
									   time:TRANSITION_TIME/spinStep, transition:"easeInOutSine", onComplete:onSpinComplete});
		}
		
		private function onSpinComplete():void {
			spinStep--;
			if (spinStep > 0) {
				swapImage();
			}
			else {
				spinning = false;
			}
			
		}
	}
}