package
{
	import flash.desktop.NativeApplication;
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.filesystem.File;
	import flash.net.SharedObject;
	import flash.net.URLRequest;

	public class PhotoList extends EventDispatcher
	{
		public static const IMAGES_LOADED:String = "event_photolist_images_loaded";
		
		private static const SO_KEY:String = "stored_PR_image_directory";
		private var so:SharedObject = SharedObject.getLocal(SO_KEY);
		
		private var imageDir:File = File.applicationDirectory;
		private var photoArray:Array = new Array();
		
		private var imageFilenameList:Array;
		private var imageList:Array;
		private var imagesToLoad:int;
		private var selectedIndex:int;
		
		public function PhotoList() {}
		
		public function init():void {
			if (so.data.imageDirPath) {
				imageDir = imageDir.resolvePath(so.data.imageDirPath);
				loadImages();
			}
			else {
				selectImageDirectory();
			}
		}
		
		public function loadImages():void {
			var imgRegex:RegExp = new RegExp("(gif|jpg|jpeg|png)$","i");
			
			imagesToLoad = 0;
			imageFilenameList = new Array();
			for each (var imageFile:File in imageDir.getDirectoryListing()) {
				if (imageFile.nativePath.match(imgRegex)) {
					imageFilenameList.push(imageFile.url);
					imagesToLoad++;
				}
			}
			
			// we're gonna do it this way for safety, not efficiency... 
			imageList = new Array();
			for each (var filename:String in imageFilenameList) {
				var loader:Loader = new Loader();
				loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoaded);
				loader.load(new URLRequest(filename));
			}
		}
		
		private function onImageLoaded(event:Event):void {
			var bitmap:Bitmap = event.target.content as Bitmap;
			imageList.push(bitmap);
			
			imagesToLoad--;
			if (imagesToLoad == 0) {
				dispatchEvent(new Event(IMAGES_LOADED));
			}
		}
		
		public function selectImageDirectory():void {
			try {
				imageDir.addEventListener(Event.SELECT, imageDirSelected);
				imageDir.browseForDirectory("Select Image Directory");
			}
			catch (error:Error) {
				trace("Image directory select failed: "+error.message);
				NativeApplication.nativeApplication.exit();
			}
		}
		
		private function imageDirSelected(event:Event):void {
			// handle cancel event TBD
			imageDir = event.target as File;
			so.data.imageDirPath = imageDir.nativePath;
			loadImages();
		}
		
		public function get nextImage():Bitmap {
			var index:int = selectedIndex;
			while (index == selectedIndex) {
				index = Math.random()*imageList.length;
			}
			selectedIndex = index;
			return imageList[index];
		}

	}
}