package {
	import flash.desktop.NativeApplication;
	import flash.display.Sprite;
	import flash.display.StageDisplayState;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	
	[SWF(width="800", height="600", backgroundColor="#000000")]
	
	public class PhotoRoulette extends Sprite {
		
		private var photos:PhotoList = new PhotoList();
		private var carouselView:CarouselView = new CarouselView(photos);
		private var info:InfoScreen = new InfoScreen();
		private var loading:LoadingScreen = new LoadingScreen();
		
		public function PhotoRoulette() {
			this.stage.nativeWindow.visible = true;
			stage.fullScreenSourceRect = new Rectangle(0, 0, 800, 600);
			addChild(carouselView);
			
			addChild(loading);
			loading.x = (stage.stageWidth - loading.width)/2;
			loading.y = (stage.stageHeight - loading.height)/2;
			addChild(info);
			info.x = (stage.stageWidth - info.width)/2;
			info.y = 20;
			info.visible = false;
			
			photos.addEventListener(PhotoList.IMAGES_LOADED, onImagesLoaded);
			addEventListener(Event.ENTER_FRAME, initPhotos);
		}	
			
		public function initPhotos(event:Event):void {
			removeEventListener(Event.ENTER_FRAME, initPhotos);
			photos.init();
		}
		
		private function onImagesLoaded(event:Event):void {
			info.visible = true;
			loading.visible = false;
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
		}
		
		private function onKeyDown(event:KeyboardEvent):void {
			switch(event.keyCode) {
				case Keyboard.SPACE: 
					if (!carouselView.spinning) {
						info.visible = false;
						carouselView.spin();
					}
					break;
				case Keyboard.ESCAPE:
					NativeApplication.nativeApplication.exit();
					break;
				case Keyboard.D:
					info.visible = false;
					loading.visible = true;
					photos.selectImageDirectory();
					break;
				case Keyboard.F:
					if (stage.displayState == StageDisplayState.NORMAL) {
						stage.displayState = StageDisplayState.FULL_SCREEN_INTERACTIVE;
					}
					else {
						stage.displayState = StageDisplayState.NORMAL;
					}
					break;
				case Keyboard.SLASH:
					info.visible = !info.visible;
					break;
			}
		}
		
	}
}